# Changelog

All notable changes to this project will be documented in this file.

### [4.2.1] - 2024-11-18
### Changed 
- **Bug Fixes**: SQLMap Error Handled.

### [4.2.1] - 2024-11-18
#### Added
- **New Nmap Functions**: Added multiple Nmap scanning options for vulnerability assessments.
- **SQLMap Integration**: Expanded SQL injection testing functionalities.
- **Enhanced System Utilities**: New features to execute system commands and retrieve system information.
- **Improved File Handling**: Enhanced operations for various file types.
- **XAMPP Functions**: Added functions for managing XAMPP MySQL and Apache services, and checking PHPMyAdmin accessibility.
- **System Utilities**: Added support for checking Python interpreter path and processor details.

#### Changed
- **General Improvements**: Optimized performance and stability across the module.

#### Fixed
- **Bug Fixes**: Enhanced error handling across file operations and database interactions.

### [3.0.2] - 2024-11-14
#### Added
- Improved XAMPP MySQL Functions.
- Improved MySQL database management functions.
- Enhanced CSV, text, and binary file handling.
- Added support for checking Python interpreter path and processor details.
- Introduced functions for managing XAMPP MySQL and Apache services.

#### Fixed
- Enhanced error handling for file operations and MySQL interactions.

#### Changed
- Updated functions to support the latest MySQL and file management enhancements.

### [2.7.5] - 2024-11-15
#### Added
- Expanded functionality to support CSV and binary file handling, including reading, writing, and checking file types.
- Additional enhancements in error handling for new file handling features.
- Updated documentation to reflect the latest changes.

### [2.7.2] - 2024-11-15
#### Added
- Added pytest and tox for testing.

### [2.6.1] - 2024-11-15
#### Added
- Documentation website.

### [2.6.0] - 2024-11-14
#### Added
- Expanded mathematical functions for prime numbers, Armstrong numbers, and Niven numbers.
- Enhanced text file handling: added functions to copy contents between files, add lines, and read specific lines.
- System utilities to fetch information such as CPU count, operating system details, Python interpreter path, and network connectivity status.
- New MySQL functions for managing and interacting with databases and tables with improved error handling.
- Time management functions: Added functions to get process time, thread time, and monotonic time.

#### Fixed
- Improved error handling for file operations and MySQL interactions.
- Fixed issues with incorrect data type handling in certain mathematical functions.

### [2.5.8]
#### Added
- Error correction methods for better handling.
- Support for returning `False` based on data type validity.

### [2.5.6]
#### Added
- Added Git support.
