# ncert_learn

**ncert_learn** is a comprehensive Python module designed to support NCERT Class 12 Computer Science students. It offers a wide range of utility functions across various topics, including Python programming, MySQL database interactions, mathematical operations, data structures, system utilities, and more.

## Key Features

### **Mathematical Functions**
- Prime number check
- Armstrong, Strong, Niven, Palindrome checks
- Fibonacci numbers, even/odd checks, and more

### **Data Structures**
- Stack operations using lists and dictionaries (push, pop, peek, display)

### **Geometric Calculations**
- Area calculations for circles, rectangles, squares, polygons, and triangles

### **Number Conversions**
- Convert integers to binary, octal, hexadecimal, and vice versa

### **MySQL Operations**
- Connect to MySQL, manage databases and tables, execute queries

### **Sorting Algorithms**
- Implementations of Bubble Sort and Insertion Sort

### **File Handling**
- Read, write, and manage text, CSV, and binary files
- File operations like copying, reading specific lines, and clearing contents

### **System Utilities**
- Fetch information about the operating system, processor, network connectivity, and Python interpreter

### **Package Management**
- Install and manage Python libraries, including bulk installation from a list

### **Time Management**
- Access current time, process time, monotonic time, and thread time

### **XAMPP Utilities**
- Start/stop XAMPP MySQL and Apache, check PHPMyAdmin access

### **Zip File Handling**
- Handle ZIP files (list contents, extract, add files)

### **Nmap Scans**
- Perform various Nmap scans such as intense scan, quick scan, OS detection, and more

### **SQLMap Scans**
- Perform SQL injection tests using SQLMap

## New Features in Version 4.2.3
- **New Nmap Functions**: Added multiple Nmap scanning options for vulnerability assessments
- **SQLMap Integration**: Expanded SQL injection testing functionalities
- **Enhanced System Utilities**: New features to execute system commands and retrieve system information
- **Improved File Handling**: Enhanced operations for various file types
- **Bug Fixes and Optimizations**: General improvements and optimizations for better performance and stability

## Disclaimer
This module is intended for educational purposes only. Using this module for any illegal activities is strictly prohibited. The authors and contributors are not responsible for any misuse of the module.

## Installation

To install **ncert_learn**, use `pip`:

```bash
pip install ncert_learn
